# cross-toolchains

## Summary
Cross-toolchains includes cross-gcc, cross-glibc and cross-binutils, it supports compiling c and c++ program how including glibc and libstdc++

## Architecture of Cross-toolchains
Cross toolchains consist of four parts whick are kernel, binutils, gcc and glibc.

We need to build cross-binutils firstly, then to build cross-gcc (not including g++ and libstdc++) secondly, then to cross build glibc (pure C version) thirdly, then to build complete cross-gcc again at last.

Now we support 4 Architectures: X86, Aarch64, Loongarch64 and Riscv64

## How to use
You can install the meta-package which contains complete all parts. For example, if you want to cross-build aarch64 ELF, then you should input

```
sudo dnf install cross-toolchains-aarch64
```

opthins are

```
cross-toolchains-x86_64
cross-toolchains-aarch64
cross-toolchains-riscv64
cross-toolchains-loongarch64
```

## Features not supported in some Architectures

* loongarch64 *
1. gold is not supported in corss-binutils

## Todo list

1. using official check instead of tesing in %check
2. Optimize compilation parameters like https://github.com/richfelker/musl-cross-make/tree/master

## Special thanks

1. AltLinux, We have gained many beneficial ideas from them
2. Loongson, They provide useful guidance for the construction of the Loongarch64 architecture

#### 参与贡献

1. Fork 本仓库
2. 新建 Feat_xxx 分支
3.  提交代码
4.  新建 Pull Request
